#ifndef _SNIFFED_PACKET_QUEUE_H
#define _SNIFFED_PACKET_QUEUE_H

/*
        sniffed-packet-queue  

        When a packet is received by the
	packet-receiver, it creates a packet-description
	which it then appends to a sniffed-packet-queue
	using the function "sniffed_packet_queue_add".
	
	Packet-descriptions can then be retrieved from
	the queue by the scan-job-manager.

	Each scan-job has an own sniffed-packet-queue.

*/


#include <linux/spinlock.h>
#include <linux/list.h>
#include <linux/time.h>

#include "sniffed_packet.h"


struct sniffed_packet_queue_node{
	struct list_head list;
	rwlock_t *lock;
	struct sniffed_packet_descr_t *packet_descr;
};


void sniffed_packet_queue_add(struct sniffed_packet_queue_node *this,
				 struct sniffed_packet_descr_t *p_descr);
struct sniffed_packet_descr_t *
sniffed_packet_queue_head(struct sniffed_packet_queue_node *this);


#endif
