#ifndef _TRIGGER_FINDING_METHOD_NODE
#define _TRIGGER_FINDING_METHOD_NODE

#include <linux/list.h>
#include <linux/time.h>

#include "../scan_jobs.h"

/**
        trigger_instance
                
	A trigger_instance is an
	instance of a trigger_finding_method
	which lives in a trigger_finding_method_list.	

*/

struct trigger_instance{
	struct list_head list;
	
	u8 method_id;
	
	/* 'timeout' is only used in trigger-state. move
	 * this somewhere else, it costs memory in flood-state.
	 */
	
	void *context;

};


/* Constructor */
struct trigger_instance *
new_trigger_instance(unsigned int method_id, int round);

/* Output-operator */
void trigger_instance_out(struct trigger_instance *this,
				     struct scan_job_t *job,
				     int round);

int trigger_instance_get_round(struct trigger_instance *this);

/* Copy-constructor */

struct trigger_instance *
copy_trigger_instance(struct trigger_instance *this);


/* Destructor */
void del_trigger_instance(struct trigger_instance *this);

#endif
